// processed by mwprepro or mwpreproC 

//	Copyright (c) 1982 Dyadic Systems Limited	

//	Standard translate tables 			

static unsigned char aplmap[128] =
// 0/8,    1/9,    2/A,    3/B,    4/C,    5/D,    6/E,    7/F	
{
SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,		// 0 
SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,		// 0 

SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,		// 1 
SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,		// 1 

SP,	DIRESIS,RPAREN,	LT,	LE,	EQ,	GT,	RBRACKET,	// 2 
OR,	AND,	NE,	DIVIDE,	COMMA,	PLUS,	POINT,	SLASH,		// 2 

ZERO,	ONE,	TWO,	THREE,	FOUR,	FIVE,	SIX,	SEVEN,		// 3 
EIGHT,	NINE,	LPAREN,	LBRACKET,SEMI,	TIMES,	COLON,	SLOPE,		// 3 

HIGH,	ALPHA,	BASE,	CAP,	DSTILE,	EPSILON,UNDER,	DEL,		// 4 
DELTA,	IOTA,	JOT,	QUOTE,	QUAD,	STILE,	TOP,	CIRCLE,		// 4 

STAR,	QUERY,	RHO,	UPSTILE,TILDE,	DOWN,	CUP,	OMEGA,		// 5 
RSHOE,	UP,	LSHOE,	LEFT,	LTACK,	RIGHT,	GE,	MINUS,		// 5 

DIAMOND,A,	B,	C,	D,	E,	F,	G,		// 6 
H,	I,	J,	K,	L,	M,	N,	O,		// 6 

P,	Q,	R,	S,	T,	U,	V,	W,		// 7 
X,	Y,	Z,	MATCH,	RTACK,	NOTMATCH,DOLLAR,SQUISH		// 7 
};

static unsigned char asciimap[] =
// 0/8,    1/9,    2/A,    3/B,    4/C,    5/D,    6/E,    7/F	
{
SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,		// 0 
BS,	SQUISH,	NEWLINE,SQUISH,	SQUISH,	LF,	SQUISH,	SQUISH,		// 0 

/* above translates added 10-10-85 DSG:		ASCII	APL
obviously				0x08	BS	BS
even though ASCII NEWLINE is LF		0x0a	NEWLINE	NEWLINE
& just to be helpful			0x0d	CR	LF
*/

SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,		// 1 
SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,		// 1 

SP,     SHRIEK, DQUOTE, HASH,   DOLLAR, PERCENT,AMPERSAND,		// 2 
#ifdef	UTS
							QUOTE,
#else//  
							SQUOTE,
#endif	// UTS 
LPAREN,	RPAREN,	STAR,	PLUS,	COMMA,	MINUS,	POINT,	SLASH,		// 2 

ZERO,	ONE,	TWO,	THREE,	FOUR,	FIVE,	SIX,	SEVEN,		// 3 
EIGHT,	NINE,	COLON,	SEMI,	LT,	EQ,	GT,	QUERY,		// 3 

ASCAT,	A,	B,	C,	D,	E,	F,	G,		// 4 
H,	I,	J,	K,	L,	M,	N,	O,		// 4 

P,	Q,	R,	S,	T,	U,	V,	W,		// 5 
X,	Y,	Z,	LBRACKET,SLOPE,RBRACKET,CIRCUMFLEX,UNDER,	// 5 

BQUOTE,	AL,	BL,	CL,	DL,	EL,	FL,	GL,		// 6 
HL,	IL,	JL,	KL,	LL,	ML,	NL,	OL,		// 6 

PL,	QL,	RL,	SL,	TL,	UL,	VL,	WL,		// 7 
XL,	YL,	ZL,	LBRACE,	ASCBAR,	RBRACE,	TILDE,	SQUISH		// 7 

#ifdef  UTS	// extend the table to length 256 
,
SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,		// 8 
SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,		// 8 

SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,		// 9 
SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,		// 9 

SQUISH, DOWN,  DIRESIS, QUAD,   DEL,    NE,     NAND,  SQUISH,		// A 
LE,     GE,    LOG,   TRANSPOSE,SQUISH, HIGH,   JOT,   BSLASH,		// A 

SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,	SQUISH,		// B 
SQUISH, SQUISH, DIVIDE, SQUISH, LEFT  ,EPSILON, RIGHT , NOR,		// B 

DELTA,  AU,     BU,     CU,     DU,     EU,     FU,     GU,		// C 
HU,     IU,     JU,     KU,     LU,     MU,     NU,     OU,		// C 

PU,     QU,     RU,     SU,     TU,     UU,     VU,     WU,		// D 
XU,     YU,     ZU,     DSTILE, BSLOPE, UPSTILE,CENT,   DELTAU,		// D 

IBEAM,  ALPHA,  BASE,   LSHOE,  RSHOE,  HYDRANT,THORN,  DGRADE,		// E 
UPGRADE,IOTA,   SQUISH, SQUISH, LAMP,   DOMINO, CAP,    CIRCLE,		// E 

RHO,QUADQUOTE,CIRCLESTILE,BCIRCLE,TOP,  CUP,    OR,     OMEGA,		// F 
TIMES,  SQUISH, SQUISH, LTACK,  UP,     RTACK, DELTILDE,SQUISH		// F 
#endif  // UTS 
};

static unsigned char unixtab[256] =
{/*
 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f	*/
127,010,012,012,' ',127,127,127,127,127,127,127,'%',047,127,127,//0
'_','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',//1
'p','q','r','s','t','u','v','w','x','y','z',127,127,'-','.',127,//2
'0','1','2','3','4','5','6','7','8','9',127,127,127,'$',127,127,//3
127,'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',//4
'P','Q','R','S','T','U','V','W','X','Y','Z','.',127,127,127,127,//5
127,'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',//6
'p','q','r','s','t','u','v','w','x','y','z','{',127,'}',127,127,//7
127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,//8
127,127,127,127,127,127,127,127,127,127,127,'[','/',127, 92,127,//9
'<',127,'=',127,'>',127,127,'^','-','+',127,127,'?',127,127,'~',//a
127,127,127,127,'*',127,127,127,127,'(',127,127,127,127,127,127,//b
'|',';',',',127,127,127,127,127,127,127,127,127,'!',127,127,127,//c
127,127,127,127,127,127,127,'"','#',127,'&',047,127,127,127,127,//d
127,127,127,127,127,127,127,'@',127,127,127,'^',127,'`','|',127,//e
':',127,127,127,127,127,127,127,')',']',127,127,127,127,127,127 //f
};

//	Copyright (c) 1982 Dyadic Systems Limited	

